﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using Infragistics.Olap;
using Infragistics.Olap.Xmla;

namespace OlapAxisWithXMLA
{
    public class ViewModel : INotifyPropertyChanged
    {
        public ViewModel()
        {
            var cubes = ApplicationServices.LoadCubes();
        }

        string _cubeName = "c1_SPTL";
        string _defaultMeasures = "";
        private XmlaDataSourceExt _adomdDataSource;
        public XmlaDataSourceExt AdomdDataSource
        {
            get
            {
                if (_adomdDataSource == null)
                {
                    _adomdDataSource = CreateAdomdDataSource();

                    _adomdDataSource.ResultChanged += AdomdDataSourceGetDescription;
                    _adomdDataSource.ResultChanged += CheckForSelectedDimensionAttributes;
                    //_adomdDataSource.ResultChanged += TriggerLoadLegendsFromResultUpdate;
                                            //_adomdDataSource.Cube="Adventure Works";
                                            //_adomdDataSource.Rows="[Date].[Calendar]";
                                            //_adomdDataSource.Columns="[Product].[Product Categories]";
                                            //_adomdDataSource.Measures = "Internet Sales Amount";
                }
                return _adomdDataSource;
            }
            set
            {
                _adomdDataSource = value;
                OnPropertyChanged("AdomdDataSource");

            }
        }


        private XmlaDataSourceExt CreateAdomdDataSource()
        {
            var adomdDataSource = new XmlaDataSourceExt();
            var connectionSettings = new AdomdConnectionSettings();

            adomdDataSource.ConnectionSettings = connectionSettings;
            var databaseName = ApplicationServices.LoadCubeSchema();
            adomdDataSource.AdomdDataProvider.DatabaseName = databaseName;
            adomdDataSource.Database = XmlaDataSource.GenerateInitialDatabase(databaseName);

            adomdDataSource.Cube = DataSourceBase.GenerateInitialCube(_cubeName);

            //adomdDataSource.Rows = new AreaItemsCollection() "[Date].[Calendar]";

            if (!string.IsNullOrEmpty(_defaultMeasures))
            {
                adomdDataSource.Measures = DataSourceBase.GenerateInitialItems(_defaultMeasures);
            }

            return adomdDataSource;
        }

        void AdomdDataSourceGetDescription(object sender, AsyncCompletedEventArgs e)
        {
            Title = AdomdDataSource.GetPlainTextTitle();
        }

        void CheckForSelectedDimensionAttributes(object sender, System.ComponentModel.AsyncCompletedEventArgs e)
        {
            //if (AdomdDataSource.Columns.Count > 0 || AdomdDataSource.Rows.Count > 0 || (WidgetType == WidgetType.Summary && AdomdDataSource.Measures.Count > 0))
            //{
            //    HasData = true;
            //    if (AdomdDataSource.Result == null || AdomdDataSource.Result.Cells == null || AdomdDataSource.Result.Cells.Cast<ICell>().All(c => c == null || c.Value == null || string.IsNullOrEmpty(c.Value.ToString())))
            //    {
            //        DataIsEmpty = true;
            //    }
            //    else
            //    {
            //        DataIsEmpty = false;
            //    }
            //}
            //else
            //{
            //    DataIsEmpty = true;
            //    HasData = false;
            //}
        }

        private string _title;
        public string Title
        {
            get
            {
                if (String.IsNullOrEmpty(_title))
                {
                    _title = "Widget";
                }
                return _title;
            }
            set
            {
                _title = value;
                OnPropertyChanged("Title");
                //}
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler hEvent = this.PropertyChanged;
            if (hEvent != null)
            {
                PropertyChangedEventArgs arg = new PropertyChangedEventArgs(propertyName);
                hEvent(this, arg);
            }
        }
    }
}